from Globals import InitializeClass
from OFS.SimpleItem import SimpleItem
from AccessControl import ClassSecurityInfo

from Products.CMFCore.utils import UniqueObject, getToolByName
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
import re

from config import ADD_CONTENT_PERMISSION,PROJECTNAME,view_permission,man_perm

def addcss_tool(self,REQUEST=None):
    """ Add a CSS Tool """
    st=css_tool()
    self._setObject("portal_css",st)
    
class css_tool(UniqueObject,  SimpleItem):
    """ CSS Manager Tool """
    meta_type = "css_tool"
    id = "portal_css"
      
    security = ClassSecurityInfo()
    configPage = PageTemplateFile('www/cssconfig', globals())
    
    manage_options = (
        {'label':'css configuration', 'action':'configPage'},
        ) + SimpleItem.manage_options
    
    def __init__(self):
        """ css tool """
	self.id="portal_css"
	self._mydic={}   


    security.declareProtected(man_perm, 'manage_delFromMapping')            
    def manage_delFromMapping(self,REQUEST=None):
	"""change mapping"""
	nl = []
	for x in self.REQUEST.form.keys():
	    if x.startswith("del_"):
	    	s = x[4:]
		
		del self._mydic[s]
	

	self._p_changed = 1
	if REQUEST:
		REQUEST.RESPONSE.redirect(REQUEST['HTTP_REFERER'])
	
	
    security.declareProtected(man_perm, 'get_cssname')            	
    def get_cssname(self,info):
        """ get the name of a css object """
        return self._mydic[info]	
	
    security.declareProtected(man_perm, 'manage_addToMapping')            
    def manage_addToMapping(self,key,val,REQUEST=None):
    	""" rein """
		
	t = self.testForObject(key)
	if t==1:
		self._mydic[key]=val
		self._p_changed = 1
	
	if REQUEST is not None:
		REQUEST.RESPONSE.redirect(REQUEST['HTTP_REFERER'])
		
    security.declareProtected(man_perm, 'testForObject')            			
    def testForObject(self,key):
        """ Test if Object exists """
	res = 0
	try:
	    o = getattr(self,key)
	    res = 1
	except:
	     res = 0
	return res
    
    security.declareProtected(man_perm, 'getmapping')            	
    def getmapping(self):
        """ raus """
	return self._mydic.items()
	 
    security.declareProtected(view_permission, 'checkForColor')            
    def checkForColor(self,color):
        """ Check if string is color """
	
	hexcolor = re.compile('#[0-9a-fA-F]{6}')
        nc =  ['black','white','red','purple','white','green','yellow','blue','grey']

	
	erg = 0
	try:
		check = hexcolor.search(color) or color.lower() in nc
		if check:
			erg = 1
		else:
			erg = 0 
	except:
		erg = 0
		
	return erg
	
    
InitializeClass(css_tool)
